// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Swagger
{
    using Models;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for EnigmaVaultAPI.
    /// </summary>
    public static partial class EnigmaVaultAPIExtensions
    {
            /// <summary>
            /// Store a card.
            /// </summary>
            /// <remarks>
            /// When a card is stored in the vault, the original card information is not
            /// retrievable by the client without the cardvault_raw scope (contact
            /// support). The CVV's ttl is set to the same ttl as the card unless the card
            /// is stored permanently. If the card is stored permanently, the CVV's ttl is
            /// set to 30 minutes. The CVV is purged after its first use or after its ttl
            /// expires, whichever comes first. After the card's ttl, the card is deleted.
            /// To make the card permanent, leave out the ttl property. The full card
            /// number can be used through the proxy endpoint. You can get the first six,
            /// the last four, full name, and expiration from /cardvault/cards (GET).
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// Card information.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='preserveFormat'>
            /// If true, a Luhn passable token is returned consisting of the original first
            /// six and last four.
            /// </param>
            public static object StoreCard(this IEnigmaVaultAPI operations, CardModel body, string xApiVersion, bool? preserveFormat = default(bool?))
            {
                return operations.StoreCardAsync(body, xApiVersion, preserveFormat).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Store a card.
            /// </summary>
            /// <remarks>
            /// When a card is stored in the vault, the original card information is not
            /// retrievable by the client without the cardvault_raw scope (contact
            /// support). The CVV's ttl is set to the same ttl as the card unless the card
            /// is stored permanently. If the card is stored permanently, the CVV's ttl is
            /// set to 30 minutes. The CVV is purged after its first use or after its ttl
            /// expires, whichever comes first. After the card's ttl, the card is deleted.
            /// To make the card permanent, leave out the ttl property. The full card
            /// number can be used through the proxy endpoint. You can get the first six,
            /// the last four, full name, and expiration from /cardvault/cards (GET).
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// Card information.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='preserveFormat'>
            /// If true, a Luhn passable token is returned consisting of the original first
            /// six and last four.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> StoreCardAsync(this IEnigmaVaultAPI operations, CardModel body, string xApiVersion, bool? preserveFormat = default(bool?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StoreCardWithHttpMessagesAsync(body, xApiVersion, preserveFormat, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a card.
            /// </summary>
            /// <remarks>
            /// Provides card data. The first six and the last four are included in the
            /// response. The ttl values represent the time remaining in seconds until that
            /// item is purged. the original card information is not retreivable by the
            /// client without the cardvault_raw scope (contact support). If you have the
            /// proper scope, use the cardvault/raw/cards endpoint.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// Expiring key for temporary access.
            /// </param>
            public static object RetrieveCard(this IEnigmaVaultAPI operations, string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?))
            {
                return operations.RetrieveCardAsync(cardToken, xApiVersion, ephemeralKey).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a card.
            /// </summary>
            /// <remarks>
            /// Provides card data. The first six and the last four are included in the
            /// response. The ttl values represent the time remaining in seconds until that
            /// item is purged. the original card information is not retreivable by the
            /// client without the cardvault_raw scope (contact support). If you have the
            /// proper scope, use the cardvault/raw/cards endpoint.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// Expiring key for temporary access.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> RetrieveCardAsync(this IEnigmaVaultAPI operations, string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.RetrieveCardWithHttpMessagesAsync(cardToken, xApiVersion, ephemeralKey, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete a card.
            /// </summary>
            /// <remarks>
            /// Returns an empty 204 response on success.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            public static object DeleteCard(this IEnigmaVaultAPI operations, string cardToken, string xApiVersion)
            {
                return operations.DeleteCardAsync(cardToken, xApiVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete a card.
            /// </summary>
            /// <remarks>
            /// Returns an empty 204 response on success.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> DeleteCardAsync(this IEnigmaVaultAPI operations, string cardToken, string xApiVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteCardWithHttpMessagesAsync(cardToken, xApiVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a card. Scope cardvault_raw only.
            /// </summary>
            /// <remarks>
            /// Special endpoint to retreive raw card data. It can only be used with the
            /// cardvault_raw scope.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// Expiring key for temporary access.
            /// </param>
            public static object RetrieveRawCard(this IEnigmaVaultAPI operations, string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?))
            {
                return operations.RetrieveRawCardAsync(cardToken, xApiVersion, ephemeralKey).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a card. Scope cardvault_raw only.
            /// </summary>
            /// <remarks>
            /// Special endpoint to retreive raw card data. It can only be used with the
            /// cardvault_raw scope.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// Expiring key for temporary access.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> RetrieveRawCardAsync(this IEnigmaVaultAPI operations, string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.RetrieveRawCardWithHttpMessagesAsync(cardToken, xApiVersion, ephemeralKey, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get an ephemeral key for a specific card token and client.
            /// </summary>
            /// <remarks>
            /// The ephemeralKey is a one time use expiring key that allows an external
            /// client to use a card token. The destinationClientId is a valid Enigma Vault
            /// clientId of the destination app. The time to live (ttl) is in seconds.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Reference to the vaulted card.
            /// </param>
            /// <param name='destinationClientId'>
            /// Enigma Vault client granted use of the ephemeralKey.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ttl'>
            /// Time to live in seconds, max of 1800 seconds. This is only applicable when
            /// the card has a ttl of 0 (permanent). Otherwise the ephemeralKey ttl is set
            /// to the card ttl.
            /// </param>
            public static object GetCardEphemeralKey(this IEnigmaVaultAPI operations, string cardToken, string destinationClientId, string xApiVersion, int? ttl = default(int?))
            {
                return operations.GetCardEphemeralKeyAsync(cardToken, destinationClientId, xApiVersion, ttl).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get an ephemeral key for a specific card token and client.
            /// </summary>
            /// <remarks>
            /// The ephemeralKey is a one time use expiring key that allows an external
            /// client to use a card token. The destinationClientId is a valid Enigma Vault
            /// clientId of the destination app. The time to live (ttl) is in seconds.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Reference to the vaulted card.
            /// </param>
            /// <param name='destinationClientId'>
            /// Enigma Vault client granted use of the ephemeralKey.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ttl'>
            /// Time to live in seconds, max of 1800 seconds. This is only applicable when
            /// the card has a ttl of 0 (permanent). Otherwise the ephemeralKey ttl is set
            /// to the card ttl.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetCardEphemeralKeyAsync(this IEnigmaVaultAPI operations, string cardToken, string destinationClientId, string xApiVersion, int? ttl = default(int?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetCardEphemeralKeyWithHttpMessagesAsync(cardToken, destinationClientId, xApiVersion, ttl, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get the current ttl of a card.
            /// </summary>
            /// <remarks>
            /// The card's time to live in seconds. Once expired the card is deleted from
            /// the vault. If -1, the card lives forever until manually deleted.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// Expiring key for temporary access.
            /// </param>
            public static object GetTtl(this IEnigmaVaultAPI operations, string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?))
            {
                return operations.GetTtlAsync(cardToken, xApiVersion, ephemeralKey).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get the current ttl of a card.
            /// </summary>
            /// <remarks>
            /// The card's time to live in seconds. Once expired the card is deleted from
            /// the vault. If -1, the card lives forever until manually deleted.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// Expiring key for temporary access.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetTtlAsync(this IEnigmaVaultAPI operations, string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetTtlWithHttpMessagesAsync(cardToken, xApiVersion, ephemeralKey, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Update the card ttl.
            /// </summary>
            /// <remarks>
            /// Adjusts the time (seconds) until deletion. Additional time cannot be added
            /// to the CVV's ttl.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// New card ttl value.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            public static object UpdateCardTtl(this IEnigmaVaultAPI operations, CardTtlModel body, string cardToken, string xApiVersion)
            {
                return operations.UpdateCardTtlAsync(body, cardToken, xApiVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Update the card ttl.
            /// </summary>
            /// <remarks>
            /// Adjusts the time (seconds) until deletion. Additional time cannot be added
            /// to the CVV's ttl.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// New card ttl value.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> UpdateCardTtlAsync(this IEnigmaVaultAPI operations, CardTtlModel body, string cardToken, string xApiVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateCardTtlWithHttpMessagesAsync(body, cardToken, xApiVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Send detokenized card data and transaction info to a payment gateway.
            /// </summary>
            /// <remarks>
            /// This endpoint allows you to use a stored card without touching the card
            /// data. Build out the request meant for the upstream url and then use the
            /// following placeholders to have the endpoint populate them with card data:
            /// ${ccn}, ${cvv}, ${fullName}, ${lastName}, ${firstName}, ${cardType}, ${mm},
            /// ${yy}, and ${yyyy}. Supports GET/PUT/POST/DELETE.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// Token and gateway information.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// Expiring key for temporary access.
            /// </param>
            public static object CardProxy(this IEnigmaVaultAPI operations, CardProxyModel body, string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?))
            {
                return operations.CardProxyAsync(body, cardToken, xApiVersion, ephemeralKey).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Send detokenized card data and transaction info to a payment gateway.
            /// </summary>
            /// <remarks>
            /// This endpoint allows you to use a stored card without touching the card
            /// data. Build out the request meant for the upstream url and then use the
            /// following placeholders to have the endpoint populate them with card data:
            /// ${ccn}, ${cvv}, ${fullName}, ${lastName}, ${firstName}, ${cardType}, ${mm},
            /// ${yy}, and ${yyyy}. Supports GET/PUT/POST/DELETE.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// Token and gateway information.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// Expiring key for temporary access.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> CardProxyAsync(this IEnigmaVaultAPI operations, CardProxyModel body, string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CardProxyWithHttpMessagesAsync(body, cardToken, xApiVersion, ephemeralKey, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a url to the card processing UI.
            /// </summary>
            /// <remarks>
            /// The card processing UI allows your customers to enter their card data and
            /// process upstream with the payment gateway without your app touching it.
            /// Build out the request meant for the upstream url and then use the following
            /// placeholders to have the endpoint populate them with card data: ${total},
            /// ${ccn}, ${cvv}, ${fullName}, ${lastName}, ${firstName}, ${cardType}, ${mm},
            /// ${yy}, and ${yyyy}. Supports GET/PUT/POST/DELETE. The customer is
            /// redirected back to your app (callback url) via POST with the parameter
            /// eVsessionId. You can then use /cardvault/process/sessions/ to determine the
            /// adjudication. The session information is available for 72 hours. If the
            /// customer choses to save their card, it will be available through the
            /// sessions endpoint. If the customer chooses to cancel or if the form
            /// timeouts, evException will have a value within the POST callback. For
            /// cancels, evException's value will be 'cancel'. For timeouts, the
            /// evException's value will be 'timeout'. There are multiple ways to integrate
            /// the card process form. You can use it within a popup, redirect or simple
            /// iframe.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// Gateway and cart information.
            /// </param>
            /// <param name='callbackUrl'>
            /// URL the user is redirected to after storing the card.
            /// </param>
            /// <param name='showTimer'>
            /// Show or hide the timer.
            /// </param>
            /// <param name='showCard'>
            /// Show or hide the card visual.
            /// </param>
            /// <param name='ttl'>
            /// Form session time to live in seconds. After it expires, the form can no
            /// longer be used.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='preserveFormat'>
            /// If true, a Luhn passable token is returned consisting of the original first
            /// six and last four.
            /// </param>
            /// <param name='cardTypes'>
            /// Card types, comma delimited. Omit for any card.
            /// (amex, diners_club_carte_blanche, diners_club_international,
            /// jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
            /// uatp, mir).
            /// </param>
            /// <param name='pageHeader'>
            /// Configurable page header.
            /// </param>
            /// <param name='submitButtonText'>
            /// Text of the submit button.
            /// </param>
            /// <param name='language'>
            /// The language to use on the form. Currently en (English), es (Spanish),
            /// fr (French), and zh-Hans (Chinese simplified) are available.
            /// </param>
            /// <param name='submitButtonColor'>
            /// The hex color of the submit button.
            /// </param>
            /// <param name='cancelButtonColor'>
            /// The hex color of the cancel button.
            /// </param>
            /// <param name='pageColor'>
            /// The hex color of the page background.
            /// </param>
            /// <param name='submitButtonTextColor'>
            /// The hex color of the submit button text.
            /// </param>
            /// <param name='cancelButtonTextColor'>
            /// The hex color of the cancel button text.
            /// </param>
            /// <param name='pageTextColor'>
            /// The hex color of the page text.
            /// </param>
            /// <param name='cartTableBorderColor'>
            /// The hex color of the cart table header and border.
            /// </param>
            /// <param name='cartTableAlternateRowColor'>
            /// The hex color of the cart table's alternating rows.
            /// </param>
            public static object GetCardProcessForm(this IEnigmaVaultAPI operations, CardProcessModel body, string callbackUrl, bool showTimer, bool showCard, int ttl, string xApiVersion, bool? preserveFormat = default(bool?), string cardTypes = default(string), string pageHeader = default(string), string submitButtonText = "Pay Now", string language = "en", string submitButtonColor = "#0078e7", string cancelButtonColor = "#f08080", string pageColor = "#ffffff", string submitButtonTextColor = "#ffffff", string cancelButtonTextColor = "#000000", string pageTextColor = "#000000", string cartTableBorderColor = "#e0e0e0", string cartTableAlternateRowColor = "#f2f2f2")
            {
                return operations.GetCardProcessFormAsync(body, callbackUrl, showTimer, showCard, ttl, xApiVersion, preserveFormat, cardTypes, pageHeader, submitButtonText, language, submitButtonColor, cancelButtonColor, pageColor, submitButtonTextColor, cancelButtonTextColor, pageTextColor, cartTableBorderColor, cartTableAlternateRowColor).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a url to the card processing UI.
            /// </summary>
            /// <remarks>
            /// The card processing UI allows your customers to enter their card data and
            /// process upstream with the payment gateway without your app touching it.
            /// Build out the request meant for the upstream url and then use the following
            /// placeholders to have the endpoint populate them with card data: ${total},
            /// ${ccn}, ${cvv}, ${fullName}, ${lastName}, ${firstName}, ${cardType}, ${mm},
            /// ${yy}, and ${yyyy}. Supports GET/PUT/POST/DELETE. The customer is
            /// redirected back to your app (callback url) via POST with the parameter
            /// eVsessionId. You can then use /cardvault/process/sessions/ to determine the
            /// adjudication. The session information is available for 72 hours. If the
            /// customer choses to save their card, it will be available through the
            /// sessions endpoint. If the customer chooses to cancel or if the form
            /// timeouts, evException will have a value within the POST callback. For
            /// cancels, evException's value will be 'cancel'. For timeouts, the
            /// evException's value will be 'timeout'. There are multiple ways to integrate
            /// the card process form. You can use it within a popup, redirect or simple
            /// iframe.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// Gateway and cart information.
            /// </param>
            /// <param name='callbackUrl'>
            /// URL the user is redirected to after storing the card.
            /// </param>
            /// <param name='showTimer'>
            /// Show or hide the timer.
            /// </param>
            /// <param name='showCard'>
            /// Show or hide the card visual.
            /// </param>
            /// <param name='ttl'>
            /// Form session time to live in seconds. After it expires, the form can no
            /// longer be used.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='preserveFormat'>
            /// If true, a Luhn passable token is returned consisting of the original first
            /// six and last four.
            /// </param>
            /// <param name='cardTypes'>
            /// Card types, comma delimited. Omit for any card.
            /// (amex, diners_club_carte_blanche, diners_club_international,
            /// jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
            /// uatp, mir).
            /// </param>
            /// <param name='pageHeader'>
            /// Configurable page header.
            /// </param>
            /// <param name='submitButtonText'>
            /// Text of the submit button.
            /// </param>
            /// <param name='language'>
            /// The language to use on the form. Currently en (English), es (Spanish),
            /// fr (French), and zh-Hans (Chinese simplified) are available.
            /// </param>
            /// <param name='submitButtonColor'>
            /// The hex color of the submit button.
            /// </param>
            /// <param name='cancelButtonColor'>
            /// The hex color of the cancel button.
            /// </param>
            /// <param name='pageColor'>
            /// The hex color of the page background.
            /// </param>
            /// <param name='submitButtonTextColor'>
            /// The hex color of the submit button text.
            /// </param>
            /// <param name='cancelButtonTextColor'>
            /// The hex color of the cancel button text.
            /// </param>
            /// <param name='pageTextColor'>
            /// The hex color of the page text.
            /// </param>
            /// <param name='cartTableBorderColor'>
            /// The hex color of the cart table header and border.
            /// </param>
            /// <param name='cartTableAlternateRowColor'>
            /// The hex color of the cart table's alternating rows.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetCardProcessFormAsync(this IEnigmaVaultAPI operations, CardProcessModel body, string callbackUrl, bool showTimer, bool showCard, int ttl, string xApiVersion, bool? preserveFormat = default(bool?), string cardTypes = default(string), string pageHeader = default(string), string submitButtonText = "Pay Now", string language = "en", string submitButtonColor = "#0078e7", string cancelButtonColor = "#f08080", string pageColor = "#ffffff", string submitButtonTextColor = "#ffffff", string cancelButtonTextColor = "#000000", string pageTextColor = "#000000", string cartTableBorderColor = "#e0e0e0", string cartTableAlternateRowColor = "#f2f2f2", CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetCardProcessFormWithHttpMessagesAsync(body, callbackUrl, showTimer, showCard, ttl, xApiVersion, preserveFormat, cardTypes, pageHeader, submitButtonText, language, submitButtonColor, cancelButtonColor, pageColor, submitButtonTextColor, cancelButtonTextColor, pageTextColor, cartTableBorderColor, cartTableAlternateRowColor, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get card process session information.
            /// </summary>
            /// <remarks>
            /// Obtain the results from the gateway and retrieve the card token if the
            /// customer decided to save it.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='id'>
            /// Session ID
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            public static object GetCardProcessSession(this IEnigmaVaultAPI operations, System.Guid id, string xApiVersion)
            {
                return operations.GetCardProcessSessionAsync(id, xApiVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get card process session information.
            /// </summary>
            /// <remarks>
            /// Obtain the results from the gateway and retrieve the card token if the
            /// customer decided to save it.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='id'>
            /// Session ID
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetCardProcessSessionAsync(this IEnigmaVaultAPI operations, System.Guid id, string xApiVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetCardProcessSessionWithHttpMessagesAsync(id, xApiVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a url to the card store UI.
            /// </summary>
            /// <remarks>
            /// The card store form allows your app to store and later use customer card
            /// data without touching it. After the cardTtl expires, the card is deleted.
            /// If the user decides to save the card, the card is stored permanently. If
            /// you're seeking to permanently store the card outside of a transaction
            /// (wallet style), set walletSave to true. If you set walletSave to true, the
            /// buttonText and cardTtl are overriden. If walletSave is true the CVV isn't
            /// requested. If you intend to use the card in a transaction within 30
            /// minutes, set walletSave to false. On callback, your app will receive via
            /// POST the card token within the parameter eVtoken. If the customer chooses
            /// to cancel or if the form timeouts, the evException parameter will contain
            /// the reason. For cancels, evException's value will be 'cancel'. For
            /// timeouts, evException's value will be 'timeout'. If embedFormForControl is
            /// set to true, pass 'submit' as a message over to the iframe to submit the
            /// form. On response, the parent will receive an object that consists of the
            /// status, the token, and CardModel object. There are multiple ways to
            /// integrate the card store form. You can use it within a popup, redirect,
            /// simple iframe, or iframe where the parent page has control to submit the
            /// form. You can find example code for the advanced iframe integration on
            /// [GitHub](https://github.com/Enigma-Vault/card-vault-integration-examples).
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='showTimer'>
            /// Show or hide the timer.
            /// </param>
            /// <param name='showCard'>
            /// Show or hide the card visual.
            /// </param>
            /// <param name='walletSave'>
            /// Make true to store the card in your app's wallet. This overrides
            /// the cardTtl and buttonText values. The CVV isn't requested if true.
            /// If you intend to use the card in a transaction within 30 minutes,
            /// set walletSave to false.
            /// </param>
            /// <param name='embedFormForControl'>
            /// If true, it removes its buttons and
            /// any additional padding/spacing, and enables the windows interface for 2-way
            /// comms.
            /// </param>
            /// <param name='ttl'>
            /// Form session time to live in seconds. After it expires, the form can no
            /// longer be used.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cardTtl'>
            /// The card's time to live in seconds (60-1800 secs).
            /// Once expired the card is deleted from the vault. Use the
            /// /cardvault/cards/ttl
            /// endpoint to extend it. This field is required if walletSave is false.
            /// </param>
            /// <param name='preserveFormat'>
            /// If true, a Luhn passable token is returned consisting of the original first
            /// six and last four.
            /// </param>
            /// <param name='cardTypes'>
            /// Card types, comma delimited. Omit for any card.
            /// (amex, diners_club_carte_blanche, diners_club_international,
            /// jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
            /// uatp, mir).
            /// </param>
            /// <param name='callbackUrl'>
            /// URL the user is redirected to after storing the card.
            /// </param>
            /// <param name='parentUrl'>
            /// The parent page URL. The store form uses it when embedFormForControl
            /// is true to communicate with the parent window.
            /// </param>
            /// <param name='pageHeader'>
            /// Configurable page header.
            /// </param>
            /// <param name='language'>
            /// The language to use on the form. Currently en (English), es (Spanish),
            /// fr (French), and zh-Hans (Chinese simplified) are available.
            /// </param>
            /// <param name='submitButtonText'>
            /// Text of the submit button.
            /// </param>
            /// <param name='submitButtonColor'>
            /// The hex color of the submit button.
            /// </param>
            /// <param name='cancelButtonColor'>
            /// The hex color of the cancel button.
            /// </param>
            /// <param name='pageColor'>
            /// The hex color of the page background.
            /// </param>
            /// <param name='submitButtonTextColor'>
            /// The hex color of the submit button text.
            /// </param>
            /// <param name='cancelButtonTextColor'>
            /// The hex color of the cancel button text.
            /// </param>
            /// <param name='pageTextColor'>
            /// The hex color of the page text.
            /// </param>
            public static object GetCardStoreForm(this IEnigmaVaultAPI operations, bool showTimer, bool showCard, bool walletSave, bool embedFormForControl, int ttl, string xApiVersion, int? cardTtl = default(int?), bool? preserveFormat = default(bool?), string cardTypes = default(string), string callbackUrl = default(string), string parentUrl = default(string), string pageHeader = default(string), string language = "en", string submitButtonText = "Save", string submitButtonColor = "#0078e7", string cancelButtonColor = "#f08080", string pageColor = "#ffffff", string submitButtonTextColor = "#ffffff", string cancelButtonTextColor = "#000000", string pageTextColor = "#000000")
            {
                return operations.GetCardStoreFormAsync(showTimer, showCard, walletSave, embedFormForControl, ttl, xApiVersion, cardTtl, preserveFormat, cardTypes, callbackUrl, parentUrl, pageHeader, language, submitButtonText, submitButtonColor, cancelButtonColor, pageColor, submitButtonTextColor, cancelButtonTextColor, pageTextColor).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a url to the card store UI.
            /// </summary>
            /// <remarks>
            /// The card store form allows your app to store and later use customer card
            /// data without touching it. After the cardTtl expires, the card is deleted.
            /// If the user decides to save the card, the card is stored permanently. If
            /// you're seeking to permanently store the card outside of a transaction
            /// (wallet style), set walletSave to true. If you set walletSave to true, the
            /// buttonText and cardTtl are overriden. If walletSave is true the CVV isn't
            /// requested. If you intend to use the card in a transaction within 30
            /// minutes, set walletSave to false. On callback, your app will receive via
            /// POST the card token within the parameter eVtoken. If the customer chooses
            /// to cancel or if the form timeouts, the evException parameter will contain
            /// the reason. For cancels, evException's value will be 'cancel'. For
            /// timeouts, evException's value will be 'timeout'. If embedFormForControl is
            /// set to true, pass 'submit' as a message over to the iframe to submit the
            /// form. On response, the parent will receive an object that consists of the
            /// status, the token, and CardModel object. There are multiple ways to
            /// integrate the card store form. You can use it within a popup, redirect,
            /// simple iframe, or iframe where the parent page has control to submit the
            /// form. You can find example code for the advanced iframe integration on
            /// [GitHub](https://github.com/Enigma-Vault/card-vault-integration-examples).
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='showTimer'>
            /// Show or hide the timer.
            /// </param>
            /// <param name='showCard'>
            /// Show or hide the card visual.
            /// </param>
            /// <param name='walletSave'>
            /// Make true to store the card in your app's wallet. This overrides
            /// the cardTtl and buttonText values. The CVV isn't requested if true.
            /// If you intend to use the card in a transaction within 30 minutes,
            /// set walletSave to false.
            /// </param>
            /// <param name='embedFormForControl'>
            /// If true, it removes its buttons and
            /// any additional padding/spacing, and enables the windows interface for 2-way
            /// comms.
            /// </param>
            /// <param name='ttl'>
            /// Form session time to live in seconds. After it expires, the form can no
            /// longer be used.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cardTtl'>
            /// The card's time to live in seconds (60-1800 secs).
            /// Once expired the card is deleted from the vault. Use the
            /// /cardvault/cards/ttl
            /// endpoint to extend it. This field is required if walletSave is false.
            /// </param>
            /// <param name='preserveFormat'>
            /// If true, a Luhn passable token is returned consisting of the original first
            /// six and last four.
            /// </param>
            /// <param name='cardTypes'>
            /// Card types, comma delimited. Omit for any card.
            /// (amex, diners_club_carte_blanche, diners_club_international,
            /// jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
            /// uatp, mir).
            /// </param>
            /// <param name='callbackUrl'>
            /// URL the user is redirected to after storing the card.
            /// </param>
            /// <param name='parentUrl'>
            /// The parent page URL. The store form uses it when embedFormForControl
            /// is true to communicate with the parent window.
            /// </param>
            /// <param name='pageHeader'>
            /// Configurable page header.
            /// </param>
            /// <param name='language'>
            /// The language to use on the form. Currently en (English), es (Spanish),
            /// fr (French), and zh-Hans (Chinese simplified) are available.
            /// </param>
            /// <param name='submitButtonText'>
            /// Text of the submit button.
            /// </param>
            /// <param name='submitButtonColor'>
            /// The hex color of the submit button.
            /// </param>
            /// <param name='cancelButtonColor'>
            /// The hex color of the cancel button.
            /// </param>
            /// <param name='pageColor'>
            /// The hex color of the page background.
            /// </param>
            /// <param name='submitButtonTextColor'>
            /// The hex color of the submit button text.
            /// </param>
            /// <param name='cancelButtonTextColor'>
            /// The hex color of the cancel button text.
            /// </param>
            /// <param name='pageTextColor'>
            /// The hex color of the page text.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetCardStoreFormAsync(this IEnigmaVaultAPI operations, bool showTimer, bool showCard, bool walletSave, bool embedFormForControl, int ttl, string xApiVersion, int? cardTtl = default(int?), bool? preserveFormat = default(bool?), string cardTypes = default(string), string callbackUrl = default(string), string parentUrl = default(string), string pageHeader = default(string), string language = "en", string submitButtonText = "Save", string submitButtonColor = "#0078e7", string cancelButtonColor = "#f08080", string pageColor = "#ffffff", string submitButtonTextColor = "#ffffff", string cancelButtonTextColor = "#000000", string pageTextColor = "#000000", CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetCardStoreFormWithHttpMessagesAsync(showTimer, showCard, walletSave, embedFormForControl, ttl, xApiVersion, cardTtl, preserveFormat, cardTypes, callbackUrl, parentUrl, pageHeader, language, submitButtonText, submitButtonColor, cancelButtonColor, pageColor, submitButtonTextColor, cancelButtonTextColor, pageTextColor, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a url to the CVV store UI.
            /// </summary>
            /// <remarks>
            /// The CVV store form allows your app to temporarily store the CVV until
            /// authorization. The CVV ttl is set to the card's ttl. If the card has a ttl
            /// of -1, the CVV ttl will be set to 1800 seconds. If autoSave is true, the
            /// callback will not trigger so the client app will need to verify the cvv ttl
            /// for its existence. There are multiple ways to integrate the cvv form. You
            /// can use it within a popup, redirect, simple iframe, (previous 3 can use
            /// autosave) or iframe where the parent page has control to submit the form.
            /// You can find example code for the advanced iframe integration on
            /// [GitHub](https://github.com/Enigma-Vault/card-vault-integration-examples).
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='showTimer'>
            /// Show or hide the timer.
            /// </param>
            /// <param name='showCancelButton'>
            /// Show or hide the cancel button.
            /// </param>
            /// <param name='autoSave'>
            /// If true, the buttons and header are removed, and cvv will be autosaved
            /// after user entry.
            /// The callback will not trigger so the client app will need to verify the cvv
            /// ttl for its existence.
            /// </param>
            /// <param name='embedFormForControl'>
            /// If true, it removes its buttons and
            /// any additional padding/spacing, and enables the windows interface for 2-way
            /// comms.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='callbackUrl'>
            /// URL the user is redirected to after storing the card.
            /// </param>
            /// <param name='parentUrl'>
            /// The parent page URL. The store form uses it when embedFormForControl
            /// is true to communicate with the parent window.
            /// </param>
            /// <param name='pageHeader'>
            /// Configurable page header.
            /// </param>
            /// <param name='language'>
            /// The language to use on the form. Currently en (English), es (Spanish),
            /// fr (French), and zh-Hans (Chinese simplified) are available.
            /// </param>
            /// <param name='submitButtonText'>
            /// Text of the submit button.
            /// </param>
            /// <param name='submitButtonColor'>
            /// The hex color of the submit button.
            /// </param>
            /// <param name='cancelButtonColor'>
            /// The hex color of the cancel button.
            /// </param>
            /// <param name='pageColor'>
            /// The hex color of the page background.
            /// </param>
            /// <param name='submitButtonTextColor'>
            /// The hex color of the submit button text.
            /// </param>
            /// <param name='cancelButtonTextColor'>
            /// The hex color of the cancel button text.
            /// </param>
            /// <param name='pageTextColor'>
            /// The hex color of the page text.
            /// </param>
            public static object GetCvvStoreForm(this IEnigmaVaultAPI operations, string cardToken, bool showTimer, bool showCancelButton, bool autoSave, bool embedFormForControl, string xApiVersion, string callbackUrl = default(string), string parentUrl = default(string), string pageHeader = default(string), string language = "en", string submitButtonText = "Submit", string submitButtonColor = "#0078e7", string cancelButtonColor = "#f08080", string pageColor = "#ffffff", string submitButtonTextColor = "#ffffff", string cancelButtonTextColor = "#000000", string pageTextColor = "#000000")
            {
                return operations.GetCvvStoreFormAsync(cardToken, showTimer, showCancelButton, autoSave, embedFormForControl, xApiVersion, callbackUrl, parentUrl, pageHeader, language, submitButtonText, submitButtonColor, cancelButtonColor, pageColor, submitButtonTextColor, cancelButtonTextColor, pageTextColor).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a url to the CVV store UI.
            /// </summary>
            /// <remarks>
            /// The CVV store form allows your app to temporarily store the CVV until
            /// authorization. The CVV ttl is set to the card's ttl. If the card has a ttl
            /// of -1, the CVV ttl will be set to 1800 seconds. If autoSave is true, the
            /// callback will not trigger so the client app will need to verify the cvv ttl
            /// for its existence. There are multiple ways to integrate the cvv form. You
            /// can use it within a popup, redirect, simple iframe, (previous 3 can use
            /// autosave) or iframe where the parent page has control to submit the form.
            /// You can find example code for the advanced iframe integration on
            /// [GitHub](https://github.com/Enigma-Vault/card-vault-integration-examples).
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='cardToken'>
            /// Card token.
            /// </param>
            /// <param name='showTimer'>
            /// Show or hide the timer.
            /// </param>
            /// <param name='showCancelButton'>
            /// Show or hide the cancel button.
            /// </param>
            /// <param name='autoSave'>
            /// If true, the buttons and header are removed, and cvv will be autosaved
            /// after user entry.
            /// The callback will not trigger so the client app will need to verify the cvv
            /// ttl for its existence.
            /// </param>
            /// <param name='embedFormForControl'>
            /// If true, it removes its buttons and
            /// any additional padding/spacing, and enables the windows interface for 2-way
            /// comms.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='callbackUrl'>
            /// URL the user is redirected to after storing the card.
            /// </param>
            /// <param name='parentUrl'>
            /// The parent page URL. The store form uses it when embedFormForControl
            /// is true to communicate with the parent window.
            /// </param>
            /// <param name='pageHeader'>
            /// Configurable page header.
            /// </param>
            /// <param name='language'>
            /// The language to use on the form. Currently en (English), es (Spanish),
            /// fr (French), and zh-Hans (Chinese simplified) are available.
            /// </param>
            /// <param name='submitButtonText'>
            /// Text of the submit button.
            /// </param>
            /// <param name='submitButtonColor'>
            /// The hex color of the submit button.
            /// </param>
            /// <param name='cancelButtonColor'>
            /// The hex color of the cancel button.
            /// </param>
            /// <param name='pageColor'>
            /// The hex color of the page background.
            /// </param>
            /// <param name='submitButtonTextColor'>
            /// The hex color of the submit button text.
            /// </param>
            /// <param name='cancelButtonTextColor'>
            /// The hex color of the cancel button text.
            /// </param>
            /// <param name='pageTextColor'>
            /// The hex color of the page text.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetCvvStoreFormAsync(this IEnigmaVaultAPI operations, string cardToken, bool showTimer, bool showCancelButton, bool autoSave, bool embedFormForControl, string xApiVersion, string callbackUrl = default(string), string parentUrl = default(string), string pageHeader = default(string), string language = "en", string submitButtonText = "Submit", string submitButtonColor = "#0078e7", string cancelButtonColor = "#f08080", string pageColor = "#ffffff", string submitButtonTextColor = "#ffffff", string cancelButtonTextColor = "#000000", string pageTextColor = "#000000", CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetCvvStoreFormWithHttpMessagesAsync(cardToken, showTimer, showCancelButton, autoSave, embedFormForControl, xApiVersion, callbackUrl, parentUrl, pageHeader, language, submitButtonText, submitButtonColor, cancelButtonColor, pageColor, submitButtonTextColor, cancelButtonTextColor, pageTextColor, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a listing of all supported cultures and currencies.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cultureCode'>
            /// ISO 639-1 (language) and ISO 3166-1 (country) code.
            /// </param>
            public static object GetCultures(this IEnigmaVaultAPI operations, string xApiVersion, string cultureCode = default(string))
            {
                return operations.GetCulturesAsync(xApiVersion, cultureCode).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a listing of all supported cultures and currencies.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cultureCode'>
            /// ISO 639-1 (language) and ISO 3166-1 (country) code.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetCulturesAsync(this IEnigmaVaultAPI operations, string xApiVersion, string cultureCode = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetCulturesWithHttpMessagesAsync(xApiVersion, cultureCode, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Store a secret.
            /// </summary>
            /// <remarks>
            /// Supports up to 5,000 plaintext objects per request. Plaintext strings must
            /// be less than 1000 characters in length. The customIdentifier attribute ties
            /// your unencrypted data to the tokens. The customIdentifier is not stored
            /// within the vault.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// Your secrets to vault.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            public static object StoreDataSecrets(this IEnigmaVaultAPI operations, IList<PlaintextCustomerIdentifierModel> body, string xApiVersion)
            {
                return operations.StoreDataSecretsAsync(body, xApiVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Store a secret.
            /// </summary>
            /// <remarks>
            /// Supports up to 5,000 plaintext objects per request. Plaintext strings must
            /// be less than 1000 characters in length. The customIdentifier attribute ties
            /// your unencrypted data to the tokens. The customIdentifier is not stored
            /// within the vault.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='body'>
            /// Your secrets to vault.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> StoreDataSecretsAsync(this IEnigmaVaultAPI operations, IList<PlaintextCustomerIdentifierModel> body, string xApiVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.StoreDataSecretsWithHttpMessagesAsync(body, xApiVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a secret by token.
            /// </summary>
            /// <remarks>
            /// The ephemeralKey is a one time use expiring key that allows an external
            /// client to obtain the token's secret. To generate one, use the
            /// datavault/secrets/ephemeralKey endpoint.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='token'>
            /// Reference to the vaulted secret.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// One time use expiring key.
            /// </param>
            public static object GetDataSecret(this IEnigmaVaultAPI operations, string token, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?))
            {
                return operations.GetDataSecretAsync(token, xApiVersion, ephemeralKey).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a secret by token.
            /// </summary>
            /// <remarks>
            /// The ephemeralKey is a one time use expiring key that allows an external
            /// client to obtain the token's secret. To generate one, use the
            /// datavault/secrets/ephemeralKey endpoint.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='token'>
            /// Reference to the vaulted secret.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// One time use expiring key.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetDataSecretAsync(this IEnigmaVaultAPI operations, string token, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetDataSecretWithHttpMessagesAsync(token, xApiVersion, ephemeralKey, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete a secret.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='token'>
            /// Reference to the vaulted secret.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            public static object DeleteDataSecret(this IEnigmaVaultAPI operations, string token, string xApiVersion)
            {
                return operations.DeleteDataSecretAsync(token, xApiVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete a secret.
            /// </summary>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='token'>
            /// Reference to the vaulted secret.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> DeleteDataSecretAsync(this IEnigmaVaultAPI operations, string token, string xApiVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteDataSecretWithHttpMessagesAsync(token, xApiVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Search by plaintext.
            /// </summary>
            /// <remarks>
            /// Exact matches will only be returned and is case sensitive.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='body'>
            /// Text to search within the vault. Exact matches will only be returned and is
            /// case sensitive.
            /// </param>
            public static object SearchDataSecrets(this IEnigmaVaultAPI operations, string xApiVersion, PlaintextModel body = default(PlaintextModel))
            {
                return operations.SearchDataSecretsAsync(xApiVersion, body).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Search by plaintext.
            /// </summary>
            /// <remarks>
            /// Exact matches will only be returned and is case sensitive.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='body'>
            /// Text to search within the vault. Exact matches will only be returned and is
            /// case sensitive.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> SearchDataSecretsAsync(this IEnigmaVaultAPI operations, string xApiVersion, PlaintextModel body = default(PlaintextModel), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.SearchDataSecretsWithHttpMessagesAsync(xApiVersion, body, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get an ephemeral key for a specific token and client.
            /// </summary>
            /// <remarks>
            /// The ephemeralKey is a one time use expiring key that allows an external
            /// client to obtain the token's secret. The destinationClientId is a valid
            /// Enigma Vault clientId of the destination app. The time to live (ttl) is in
            /// seconds.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='token'>
            /// Reference to the vaulted secret.
            /// </param>
            /// <param name='destinationClientId'>
            /// Enigma Vault client granted use of the ephemeralKey.
            /// </param>
            /// <param name='ttl'>
            /// Time to live in seconds, max of 300.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            public static object GetDataEphemeralKey(this IEnigmaVaultAPI operations, string token, string destinationClientId, int ttl, string xApiVersion)
            {
                return operations.GetDataEphemeralKeyAsync(token, destinationClientId, ttl, xApiVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get an ephemeral key for a specific token and client.
            /// </summary>
            /// <remarks>
            /// The ephemeralKey is a one time use expiring key that allows an external
            /// client to obtain the token's secret. The destinationClientId is a valid
            /// Enigma Vault clientId of the destination app. The time to live (ttl) is in
            /// seconds.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='token'>
            /// Reference to the vaulted secret.
            /// </param>
            /// <param name='destinationClientId'>
            /// Enigma Vault client granted use of the ephemeralKey.
            /// </param>
            /// <param name='ttl'>
            /// Time to live in seconds, max of 300.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetDataEphemeralKeyAsync(this IEnigmaVaultAPI operations, string token, string destinationClientId, int ttl, string xApiVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetDataEphemeralKeyWithHttpMessagesAsync(token, destinationClientId, ttl, xApiVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a url to upload a file.
            /// </summary>
            /// <remarks>
            /// The url is used to upload (PUT) a file into the vault. The url has an
            /// exipration of five minutes. The file size cannot exceed 5 gigabytes. A
            /// websocket url is provided so that the status of the file can be tracked in
            /// realtime.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='contentType'>
            /// The MIME type associated with the file.
            /// </param>
            /// <param name='fileExtension'>
            /// The file extension without the leading .
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            public static object GetUploadUrl(this IEnigmaVaultAPI operations, string contentType, string fileExtension, string xApiVersion)
            {
                return operations.GetUploadUrlAsync(contentType, fileExtension, xApiVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a url to upload a file.
            /// </summary>
            /// <remarks>
            /// The url is used to upload (PUT) a file into the vault. The url has an
            /// exipration of five minutes. The file size cannot exceed 5 gigabytes. A
            /// websocket url is provided so that the status of the file can be tracked in
            /// realtime.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='contentType'>
            /// The MIME type associated with the file.
            /// </param>
            /// <param name='fileExtension'>
            /// The file extension without the leading .
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetUploadUrlAsync(this IEnigmaVaultAPI operations, string contentType, string fileExtension, string xApiVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetUploadUrlWithHttpMessagesAsync(contentType, fileExtension, xApiVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get the status of a file.
            /// </summary>
            /// <remarks>
            /// This endpoint has been deprecated because the file status is now provided
            /// through a websocket API.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fileName'>
            /// Tokenized file name.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static object GetFileStatus(this IEnigmaVaultAPI operations, string fileName, string xApiVersion)
            {
                return operations.GetFileStatusAsync(fileName, xApiVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get the status of a file.
            /// </summary>
            /// <remarks>
            /// This endpoint has been deprecated because the file status is now provided
            /// through a websocket API.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fileName'>
            /// Tokenized file name.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            [System.Obsolete("This operation is deprecated. Please do not use it any longer.")]
            public static async Task<object> GetFileStatusAsync(this IEnigmaVaultAPI operations, string fileName, string xApiVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetFileStatusWithHttpMessagesAsync(fileName, xApiVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get a url to decrypt and download the file.
            /// </summary>
            /// <remarks>
            /// The url is used to download the file out of the vault. The url has an
            /// exipration of five minutes. When aSync is set to true for large files, a
            /// websocket API url is returned so that the file status can be monitored in
            /// real time. When the file is finished decrypting, the download url is
            /// provided through the websocket connection.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fileName'>
            /// Tokenized file name.
            /// </param>
            /// <param name='aSyncParameter'>
            /// Set to true to decrypt large files; you'll use the websocket API for
            /// notifications.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// One time use expiring key.
            /// </param>
            public static object GetDownloadUrl(this IEnigmaVaultAPI operations, string fileName, bool aSyncParameter, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?))
            {
                return operations.GetDownloadUrlAsync(fileName, aSyncParameter, xApiVersion, ephemeralKey).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get a url to decrypt and download the file.
            /// </summary>
            /// <remarks>
            /// The url is used to download the file out of the vault. The url has an
            /// exipration of five minutes. When aSync is set to true for large files, a
            /// websocket API url is returned so that the file status can be monitored in
            /// real time. When the file is finished decrypting, the download url is
            /// provided through the websocket connection.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fileName'>
            /// Tokenized file name.
            /// </param>
            /// <param name='aSyncParameter'>
            /// Set to true to decrypt large files; you'll use the websocket API for
            /// notifications.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='ephemeralKey'>
            /// One time use expiring key.
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetDownloadUrlAsync(this IEnigmaVaultAPI operations, string fileName, bool aSyncParameter, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetDownloadUrlWithHttpMessagesAsync(fileName, aSyncParameter, xApiVersion, ephemeralKey, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Delete a file.
            /// </summary>
            /// <remarks>
            /// On successful deletion, a 204 response is returned.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fileName'>
            /// Tokenized file name.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            public static object DeleteFile(this IEnigmaVaultAPI operations, string fileName, string xApiVersion)
            {
                return operations.DeleteFileAsync(fileName, xApiVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Delete a file.
            /// </summary>
            /// <remarks>
            /// On successful deletion, a 204 response is returned.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fileName'>
            /// Tokenized file name.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> DeleteFileAsync(this IEnigmaVaultAPI operations, string fileName, string xApiVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.DeleteFileWithHttpMessagesAsync(fileName, xApiVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// Get an ephemeral key for a specific fileName and client.
            /// </summary>
            /// <remarks>
            /// The ephemeralKey is a one time use expiring key that allows an external
            /// client to obtain a download url. The destinationClientId is a valid Enigma
            /// Vault clientId of the destination app. The time to live (ttl) is in
            /// seconds.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fileName'>
            /// Tokenized file name.
            /// </param>
            /// <param name='destinationClientId'>
            /// Enigma Vault client granted use of the ephemeralKey.
            /// </param>
            /// <param name='ttl'>
            /// Time to live in seconds, max of 300.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            public static object GetFileEphemeralKey(this IEnigmaVaultAPI operations, string fileName, string destinationClientId, int ttl, string xApiVersion)
            {
                return operations.GetFileEphemeralKeyAsync(fileName, destinationClientId, ttl, xApiVersion).GetAwaiter().GetResult();
            }

            /// <summary>
            /// Get an ephemeral key for a specific fileName and client.
            /// </summary>
            /// <remarks>
            /// The ephemeralKey is a one time use expiring key that allows an external
            /// client to obtain a download url. The destinationClientId is a valid Enigma
            /// Vault clientId of the destination app. The time to live (ttl) is in
            /// seconds.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='fileName'>
            /// Tokenized file name.
            /// </param>
            /// <param name='destinationClientId'>
            /// Enigma Vault client granted use of the ephemeralKey.
            /// </param>
            /// <param name='ttl'>
            /// Time to live in seconds, max of 300.
            /// </param>
            /// <param name='xApiVersion'>
            /// The requested API version
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<object> GetFileEphemeralKeyAsync(this IEnigmaVaultAPI operations, string fileName, string destinationClientId, int ttl, string xApiVersion, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetFileEphemeralKeyWithHttpMessagesAsync(fileName, destinationClientId, ttl, xApiVersion, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
