// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Swagger
{
    using Microsoft.Rest;
    using Models;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// ## Welcome to Enigma Vault's API Documentation
    ///
    /// Enigma Vault encrypts and tokenizes data of all shapes and sizes.
    /// Enigma Vault provides the following services:
    ///
    /// - **Card Vault**: encrypts and tokenizes card data. One way in and no
    /// way out except through our proxy services.
    /// - **Data Vault**: encrypts and tokenizes data. Encrypted data can be
    /// easily searched and retrieved.
    /// - **File Vault**: encrypts and stores files up to 5 GB in size.
    ///
    /// To get started, head on over to our [AWS Marketplace
    /// page](https://aws.amazon.com/marketplace/seller-profile?id=c77b8db1-5511-48b7-8ce5-9a8d4a1a8018)
    /// and select one of our offerings. Once you have credentials, feel free
    /// to use the [PostMan app](https://www.postman.com/downloads/)
    /// or our [Swagger UI](https://api.enigmavault.io/index.html).
    ///
    /// Enigma Vault utilizes AWS Lambda for performance and security reasons.
    /// Are you using Lambda as well? You can integrate using your favorite
    /// runtime http client or you can also use one of the SDKs below.
    ///
    /// ## Version 1.5 Notes
    /// ### 02/06/2022
    /// - Card Vault: you can now generate Luhn passable tokens that preserve
    /// the first six and last four of the card number. Because the tokens look
    /// like card numbers, the token has been moved to the header.
    /// ## SDKs
    ///
    /// -
    /// [C#](https://www.enigmavault.io/sdks/1.5/enigma-vault-csharp-sdk-1.5.zip)
    /// -
    /// [Java](https://www.enigmavault.io/sdks/1.5/enigma-vault-java-sdk-1.5.zip)
    /// -
    /// [Python](https://www.enigmavault.io/sdks/1.5/enigma-vault-python-sdk-1.5.zip)
    /// -
    /// [Node.js](https://www.enigmavault.io/sdks/1.5/enigma-vault-nodejs-sdk-1.5.zip)
    /// - [Go](https://www.enigmavault.io/sdks/1.5/enigma-vault-go-sdk-1.5.zip)
    /// </summary>
    public partial interface IEnigmaVaultAPI : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Subscription credentials which uniquely identify client
        /// subscription.
        /// </summary>
        ServiceClientCredentials Credentials { get; }


        /// <summary>
        /// Store a card.
        /// </summary>
        /// <remarks>
        /// When a card is stored in the vault, the original card information
        /// is not retrievable by the client without the cardvault_raw scope
        /// (contact support). The CVV's ttl is set to the same ttl as the card
        /// unless the card is stored permanently. If the card is stored
        /// permanently, the CVV's ttl is set to 30 minutes. The CVV is purged
        /// after its first use or after its ttl expires, whichever comes
        /// first. After the card's ttl, the card is deleted. To make the card
        /// permanent, leave out the ttl property. The full card number can be
        /// used through the proxy endpoint. You can get the first six, the
        /// last four, full name, and expiration from /cardvault/cards (GET).
        /// </remarks>
        /// <param name='body'>
        /// Card information.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='preserveFormat'>
        /// If true, a Luhn passable token is returned consisting of the
        /// original first six and last four.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> StoreCardWithHttpMessagesAsync(CardModel body, string xApiVersion, bool? preserveFormat = default(bool?), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get a card.
        /// </summary>
        /// <remarks>
        /// Provides card data. The first six and the last four are included in
        /// the response. The ttl values represent the time remaining in
        /// seconds until that item is purged. the original card information is
        /// not retreivable by the client without the cardvault_raw scope
        /// (contact support). If you have the proper scope, use the
        /// cardvault/raw/cards endpoint.
        /// </remarks>
        /// <param name='cardToken'>
        /// Card token.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='ephemeralKey'>
        /// Expiring key for temporary access.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> RetrieveCardWithHttpMessagesAsync(string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Delete a card.
        /// </summary>
        /// <remarks>
        /// Returns an empty 204 response on success.
        /// </remarks>
        /// <param name='cardToken'>
        /// Card token.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> DeleteCardWithHttpMessagesAsync(string cardToken, string xApiVersion, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get a card. Scope cardvault_raw only.
        /// </summary>
        /// <remarks>
        /// Special endpoint to retreive raw card data. It can only be used
        /// with the cardvault_raw scope.
        /// </remarks>
        /// <param name='cardToken'>
        /// Card token.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='ephemeralKey'>
        /// Expiring key for temporary access.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> RetrieveRawCardWithHttpMessagesAsync(string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get an ephemeral key for a specific card token and client.
        /// </summary>
        /// <remarks>
        /// The ephemeralKey is a one time use expiring key that allows an
        /// external client to use a card token. The destinationClientId is a
        /// valid Enigma Vault clientId of the destination app. The time to
        /// live (ttl) is in seconds.
        /// </remarks>
        /// <param name='cardToken'>
        /// Reference to the vaulted card.
        /// </param>
        /// <param name='destinationClientId'>
        /// Enigma Vault client granted use of the ephemeralKey.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='ttl'>
        /// Time to live in seconds, max of 1800 seconds. This is only
        /// applicable when
        /// the card has a ttl of 0 (permanent). Otherwise the ephemeralKey ttl
        /// is set to the card ttl.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetCardEphemeralKeyWithHttpMessagesAsync(string cardToken, string destinationClientId, string xApiVersion, int? ttl = default(int?), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get the current ttl of a card.
        /// </summary>
        /// <remarks>
        /// The card's time to live in seconds. Once expired the card is
        /// deleted from the vault. If -1, the card lives forever until
        /// manually deleted.
        /// </remarks>
        /// <param name='cardToken'>
        /// Card token.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='ephemeralKey'>
        /// Expiring key for temporary access.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetTtlWithHttpMessagesAsync(string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Update the card ttl.
        /// </summary>
        /// <remarks>
        /// Adjusts the time (seconds) until deletion. Additional time cannot
        /// be added to the CVV's ttl.
        /// </remarks>
        /// <param name='body'>
        /// New card ttl value.
        /// </param>
        /// <param name='cardToken'>
        /// Card token.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> UpdateCardTtlWithHttpMessagesAsync(CardTtlModel body, string cardToken, string xApiVersion, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Send detokenized card data and transaction info to a payment
        /// gateway.
        /// </summary>
        /// <remarks>
        /// This endpoint allows you to use a stored card without touching the
        /// card data. Build out the request meant for the upstream url and
        /// then use the following placeholders to have the endpoint populate
        /// them with card data: ${ccn}, ${cvv}, ${fullName}, ${lastName},
        /// ${firstName}, ${cardType}, ${mm}, ${yy}, and ${yyyy}. Supports
        /// GET/PUT/POST/DELETE.
        /// </remarks>
        /// <param name='body'>
        /// Token and gateway information.
        /// </param>
        /// <param name='cardToken'>
        /// Card token.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='ephemeralKey'>
        /// Expiring key for temporary access.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> CardProxyWithHttpMessagesAsync(CardProxyModel body, string cardToken, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get a url to the card processing UI.
        /// </summary>
        /// <remarks>
        /// The card processing UI allows your customers to enter their card
        /// data and process upstream with the payment gateway without your app
        /// touching it. Build out the request meant for the upstream url and
        /// then use the following placeholders to have the endpoint populate
        /// them with card data: ${total}, ${ccn}, ${cvv}, ${fullName},
        /// ${lastName}, ${firstName}, ${cardType}, ${mm}, ${yy}, and ${yyyy}.
        /// Supports GET/PUT/POST/DELETE. The customer is redirected back to
        /// your app (callback url) via POST with the parameter eVsessionId.
        /// You can then use /cardvault/process/sessions/ to determine the
        /// adjudication. The session information is available for 72 hours. If
        /// the customer choses to save their card, it will be available
        /// through the sessions endpoint. If the customer chooses to cancel or
        /// if the form timeouts, evException will have a value within the POST
        /// callback. For cancels, evException's value will be 'cancel'. For
        /// timeouts, the evException's value will be 'timeout'. There are
        /// multiple ways to integrate the card process form. You can use it
        /// within a popup, redirect or simple iframe.
        /// </remarks>
        /// <param name='body'>
        /// Gateway and cart information.
        /// </param>
        /// <param name='callbackUrl'>
        /// URL the user is redirected to after storing the card.
        /// </param>
        /// <param name='showTimer'>
        /// Show or hide the timer.
        /// </param>
        /// <param name='showCard'>
        /// Show or hide the card visual.
        /// </param>
        /// <param name='ttl'>
        /// Form session time to live in seconds. After it expires, the form
        /// can no
        /// longer be used.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='preserveFormat'>
        /// If true, a Luhn passable token is returned consisting of the
        /// original first six and last four.
        /// </param>
        /// <param name='cardTypes'>
        /// Card types, comma delimited. Omit for any card.
        /// (amex, diners_club_carte_blanche, diners_club_international,
        /// jcb, laser, visa_electron, visa, mastercard, discover, dankort,
        /// maestro, uatp, mir).
        /// </param>
        /// <param name='pageHeader'>
        /// Configurable page header.
        /// </param>
        /// <param name='submitButtonText'>
        /// Text of the submit button.
        /// </param>
        /// <param name='language'>
        /// The language to use on the form. Currently en (English), es
        /// (Spanish),
        /// fr (French), and zh-Hans (Chinese simplified) are available.
        /// </param>
        /// <param name='submitButtonColor'>
        /// The hex color of the submit button.
        /// </param>
        /// <param name='cancelButtonColor'>
        /// The hex color of the cancel button.
        /// </param>
        /// <param name='pageColor'>
        /// The hex color of the page background.
        /// </param>
        /// <param name='submitButtonTextColor'>
        /// The hex color of the submit button text.
        /// </param>
        /// <param name='cancelButtonTextColor'>
        /// The hex color of the cancel button text.
        /// </param>
        /// <param name='pageTextColor'>
        /// The hex color of the page text.
        /// </param>
        /// <param name='cartTableBorderColor'>
        /// The hex color of the cart table header and border.
        /// </param>
        /// <param name='cartTableAlternateRowColor'>
        /// The hex color of the cart table's alternating rows.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetCardProcessFormWithHttpMessagesAsync(CardProcessModel body, string callbackUrl, bool showTimer, bool showCard, int ttl, string xApiVersion, bool? preserveFormat = default(bool?), string cardTypes = default(string), string pageHeader = default(string), string submitButtonText = "Pay Now", string language = "en", string submitButtonColor = "#0078e7", string cancelButtonColor = "#f08080", string pageColor = "#ffffff", string submitButtonTextColor = "#ffffff", string cancelButtonTextColor = "#000000", string pageTextColor = "#000000", string cartTableBorderColor = "#e0e0e0", string cartTableAlternateRowColor = "#f2f2f2", Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get card process session information.
        /// </summary>
        /// <remarks>
        /// Obtain the results from the gateway and retrieve the card token if
        /// the customer decided to save it.
        /// </remarks>
        /// <param name='id'>
        /// Session ID
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetCardProcessSessionWithHttpMessagesAsync(System.Guid id, string xApiVersion, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get a url to the card store UI.
        /// </summary>
        /// <remarks>
        /// The card store form allows your app to store and later use customer
        /// card data without touching it. After the cardTtl expires, the card
        /// is deleted. If the user decides to save the card, the card is
        /// stored permanently. If you're seeking to permanently store the card
        /// outside of a transaction (wallet style), set walletSave to true. If
        /// you set walletSave to true, the buttonText and cardTtl are
        /// overriden. If walletSave is true the CVV isn't requested. If you
        /// intend to use the card in a transaction within 30 minutes, set
        /// walletSave to false. On callback, your app will receive via POST
        /// the card token within the parameter eVtoken. If the customer
        /// chooses to cancel or if the form timeouts, the evException
        /// parameter will contain the reason. For cancels, evException's value
        /// will be 'cancel'. For timeouts, evException's value will be
        /// 'timeout'. If embedFormForControl is set to true, pass 'submit' as
        /// a message over to the iframe to submit the form. On response, the
        /// parent will receive an object that consists of the status, the
        /// token, and CardModel object. There are multiple ways to integrate
        /// the card store form. You can use it within a popup, redirect,
        /// simple iframe, or iframe where the parent page has control to
        /// submit the form. You can find example code for the advanced iframe
        /// integration on
        /// [GitHub](https://github.com/Enigma-Vault/card-vault-integration-examples).
        /// </remarks>
        /// <param name='showTimer'>
        /// Show or hide the timer.
        /// </param>
        /// <param name='showCard'>
        /// Show or hide the card visual.
        /// </param>
        /// <param name='walletSave'>
        /// Make true to store the card in your app's wallet. This overrides
        /// the cardTtl and buttonText values. The CVV isn't requested if true.
        /// If you intend to use the card in a transaction within 30 minutes,
        /// set walletSave to false.
        /// </param>
        /// <param name='embedFormForControl'>
        /// If true, it removes its buttons and
        /// any additional padding/spacing, and enables the windows interface
        /// for 2-way comms.
        /// </param>
        /// <param name='ttl'>
        /// Form session time to live in seconds. After it expires, the form
        /// can no
        /// longer be used.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='cardTtl'>
        /// The card's time to live in seconds (60-1800 secs).
        /// Once expired the card is deleted from the vault. Use the
        /// /cardvault/cards/ttl
        /// endpoint to extend it. This field is required if walletSave is
        /// false.
        /// </param>
        /// <param name='preserveFormat'>
        /// If true, a Luhn passable token is returned consisting of the
        /// original first six and last four.
        /// </param>
        /// <param name='cardTypes'>
        /// Card types, comma delimited. Omit for any card.
        /// (amex, diners_club_carte_blanche, diners_club_international,
        /// jcb, laser, visa_electron, visa, mastercard, discover, dankort,
        /// maestro, uatp, mir).
        /// </param>
        /// <param name='callbackUrl'>
        /// URL the user is redirected to after storing the card.
        /// </param>
        /// <param name='parentUrl'>
        /// The parent page URL. The store form uses it when
        /// embedFormForControl
        /// is true to communicate with the parent window.
        /// </param>
        /// <param name='pageHeader'>
        /// Configurable page header.
        /// </param>
        /// <param name='language'>
        /// The language to use on the form. Currently en (English), es
        /// (Spanish),
        /// fr (French), and zh-Hans (Chinese simplified) are available.
        /// </param>
        /// <param name='submitButtonText'>
        /// Text of the submit button.
        /// </param>
        /// <param name='submitButtonColor'>
        /// The hex color of the submit button.
        /// </param>
        /// <param name='cancelButtonColor'>
        /// The hex color of the cancel button.
        /// </param>
        /// <param name='pageColor'>
        /// The hex color of the page background.
        /// </param>
        /// <param name='submitButtonTextColor'>
        /// The hex color of the submit button text.
        /// </param>
        /// <param name='cancelButtonTextColor'>
        /// The hex color of the cancel button text.
        /// </param>
        /// <param name='pageTextColor'>
        /// The hex color of the page text.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetCardStoreFormWithHttpMessagesAsync(bool showTimer, bool showCard, bool walletSave, bool embedFormForControl, int ttl, string xApiVersion, int? cardTtl = default(int?), bool? preserveFormat = default(bool?), string cardTypes = default(string), string callbackUrl = default(string), string parentUrl = default(string), string pageHeader = default(string), string language = "en", string submitButtonText = "Save", string submitButtonColor = "#0078e7", string cancelButtonColor = "#f08080", string pageColor = "#ffffff", string submitButtonTextColor = "#ffffff", string cancelButtonTextColor = "#000000", string pageTextColor = "#000000", Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get a url to the CVV store UI.
        /// </summary>
        /// <remarks>
        /// The CVV store form allows your app to temporarily store the CVV
        /// until authorization. The CVV ttl is set to the card's ttl. If the
        /// card has a ttl of -1, the CVV ttl will be set to 1800 seconds. If
        /// autoSave is true, the callback will not trigger so the client app
        /// will need to verify the cvv ttl for its existence. There are
        /// multiple ways to integrate the cvv form. You can use it within a
        /// popup, redirect, simple iframe, (previous 3 can use autosave) or
        /// iframe where the parent page has control to submit the form. You
        /// can find example code for the advanced iframe integration on
        /// [GitHub](https://github.com/Enigma-Vault/card-vault-integration-examples).
        /// </remarks>
        /// <param name='cardToken'>
        /// Card token.
        /// </param>
        /// <param name='showTimer'>
        /// Show or hide the timer.
        /// </param>
        /// <param name='showCancelButton'>
        /// Show or hide the cancel button.
        /// </param>
        /// <param name='autoSave'>
        /// If true, the buttons and header are removed, and cvv will be
        /// autosaved after user entry.
        /// The callback will not trigger so the client app will need to verify
        /// the cvv ttl for its existence.
        /// </param>
        /// <param name='embedFormForControl'>
        /// If true, it removes its buttons and
        /// any additional padding/spacing, and enables the windows interface
        /// for 2-way comms.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='callbackUrl'>
        /// URL the user is redirected to after storing the card.
        /// </param>
        /// <param name='parentUrl'>
        /// The parent page URL. The store form uses it when
        /// embedFormForControl
        /// is true to communicate with the parent window.
        /// </param>
        /// <param name='pageHeader'>
        /// Configurable page header.
        /// </param>
        /// <param name='language'>
        /// The language to use on the form. Currently en (English), es
        /// (Spanish),
        /// fr (French), and zh-Hans (Chinese simplified) are available.
        /// </param>
        /// <param name='submitButtonText'>
        /// Text of the submit button.
        /// </param>
        /// <param name='submitButtonColor'>
        /// The hex color of the submit button.
        /// </param>
        /// <param name='cancelButtonColor'>
        /// The hex color of the cancel button.
        /// </param>
        /// <param name='pageColor'>
        /// The hex color of the page background.
        /// </param>
        /// <param name='submitButtonTextColor'>
        /// The hex color of the submit button text.
        /// </param>
        /// <param name='cancelButtonTextColor'>
        /// The hex color of the cancel button text.
        /// </param>
        /// <param name='pageTextColor'>
        /// The hex color of the page text.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetCvvStoreFormWithHttpMessagesAsync(string cardToken, bool showTimer, bool showCancelButton, bool autoSave, bool embedFormForControl, string xApiVersion, string callbackUrl = default(string), string parentUrl = default(string), string pageHeader = default(string), string language = "en", string submitButtonText = "Submit", string submitButtonColor = "#0078e7", string cancelButtonColor = "#f08080", string pageColor = "#ffffff", string submitButtonTextColor = "#ffffff", string cancelButtonTextColor = "#000000", string pageTextColor = "#000000", Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get a listing of all supported cultures and currencies.
        /// </summary>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='cultureCode'>
        /// ISO 639-1 (language) and ISO 3166-1 (country) code.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetCulturesWithHttpMessagesAsync(string xApiVersion, string cultureCode = default(string), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Store a secret.
        /// </summary>
        /// <remarks>
        /// Supports up to 5,000 plaintext objects per request. Plaintext
        /// strings must be less than 1000 characters in length. The
        /// customIdentifier attribute ties your unencrypted data to the
        /// tokens. The customIdentifier is not stored within the vault.
        /// </remarks>
        /// <param name='body'>
        /// Your secrets to vault.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> StoreDataSecretsWithHttpMessagesAsync(IList<PlaintextCustomerIdentifierModel> body, string xApiVersion, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get a secret by token.
        /// </summary>
        /// <remarks>
        /// The ephemeralKey is a one time use expiring key that allows an
        /// external client to obtain the token's secret. To generate one, use
        /// the datavault/secrets/ephemeralKey endpoint.
        /// </remarks>
        /// <param name='token'>
        /// Reference to the vaulted secret.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='ephemeralKey'>
        /// One time use expiring key.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetDataSecretWithHttpMessagesAsync(string token, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Delete a secret.
        /// </summary>
        /// <param name='token'>
        /// Reference to the vaulted secret.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> DeleteDataSecretWithHttpMessagesAsync(string token, string xApiVersion, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Search by plaintext.
        /// </summary>
        /// <remarks>
        /// Exact matches will only be returned and is case sensitive.
        /// </remarks>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='body'>
        /// Text to search within the vault. Exact matches will only be
        /// returned and is case sensitive.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> SearchDataSecretsWithHttpMessagesAsync(string xApiVersion, PlaintextModel body = default(PlaintextModel), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get an ephemeral key for a specific token and client.
        /// </summary>
        /// <remarks>
        /// The ephemeralKey is a one time use expiring key that allows an
        /// external client to obtain the token's secret. The
        /// destinationClientId is a valid Enigma Vault clientId of the
        /// destination app. The time to live (ttl) is in seconds.
        /// </remarks>
        /// <param name='token'>
        /// Reference to the vaulted secret.
        /// </param>
        /// <param name='destinationClientId'>
        /// Enigma Vault client granted use of the ephemeralKey.
        /// </param>
        /// <param name='ttl'>
        /// Time to live in seconds, max of 300.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetDataEphemeralKeyWithHttpMessagesAsync(string token, string destinationClientId, int ttl, string xApiVersion, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get a url to upload a file.
        /// </summary>
        /// <remarks>
        /// The url is used to upload (PUT) a file into the vault. The url has
        /// an exipration of five minutes. The file size cannot exceed 5
        /// gigabytes. A websocket url is provided so that the status of the
        /// file can be tracked in realtime.
        /// </remarks>
        /// <param name='contentType'>
        /// The MIME type associated with the file.
        /// </param>
        /// <param name='fileExtension'>
        /// The file extension without the leading .
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetUploadUrlWithHttpMessagesAsync(string contentType, string fileExtension, string xApiVersion, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get the status of a file.
        /// </summary>
        /// <remarks>
        /// This endpoint has been deprecated because the file status is now
        /// provided through a websocket API.
        /// </remarks>
        /// <param name='fileName'>
        /// Tokenized file name.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetFileStatusWithHttpMessagesAsync(string fileName, string xApiVersion, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get a url to decrypt and download the file.
        /// </summary>
        /// <remarks>
        /// The url is used to download the file out of the vault. The url has
        /// an exipration of five minutes. When aSync is set to true for large
        /// files, a websocket API url is returned so that the file status can
        /// be monitored in real time. When the file is finished decrypting,
        /// the download url is provided through the websocket connection.
        /// </remarks>
        /// <param name='fileName'>
        /// Tokenized file name.
        /// </param>
        /// <param name='aSyncParameter'>
        /// Set to true to decrypt large files; you'll use the websocket API
        /// for notifications.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='ephemeralKey'>
        /// One time use expiring key.
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetDownloadUrlWithHttpMessagesAsync(string fileName, bool aSyncParameter, string xApiVersion, System.Guid? ephemeralKey = default(System.Guid?), Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Delete a file.
        /// </summary>
        /// <remarks>
        /// On successful deletion, a 204 response is returned.
        /// </remarks>
        /// <param name='fileName'>
        /// Tokenized file name.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> DeleteFileWithHttpMessagesAsync(string fileName, string xApiVersion, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

        /// <summary>
        /// Get an ephemeral key for a specific fileName and client.
        /// </summary>
        /// <remarks>
        /// The ephemeralKey is a one time use expiring key that allows an
        /// external client to obtain a download url. The destinationClientId
        /// is a valid Enigma Vault clientId of the destination app. The time
        /// to live (ttl) is in seconds.
        /// </remarks>
        /// <param name='fileName'>
        /// Tokenized file name.
        /// </param>
        /// <param name='destinationClientId'>
        /// Enigma Vault client granted use of the ephemeralKey.
        /// </param>
        /// <param name='ttl'>
        /// Time to live in seconds, max of 300.
        /// </param>
        /// <param name='xApiVersion'>
        /// The requested API version
        /// </param>
        /// <param name='customHeaders'>
        /// The headers that will be added to request.
        /// </param>
        /// <param name='cancellationToken'>
        /// The cancellation token.
        /// </param>
        Task<HttpOperationResponse<object>> GetFileEphemeralKeyWithHttpMessagesAsync(string fileName, string destinationClientId, int ttl, string xApiVersion, Dictionary<string, List<string>> customHeaders = null, CancellationToken cancellationToken = default(CancellationToken));

    }
}
