// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Swagger.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    public partial class CardModel
    {
        /// <summary>
        /// Initializes a new instance of the CardModel class.
        /// </summary>
        public CardModel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CardModel class.
        /// </summary>
        /// <param name="ccn">Card number.</param>
        /// <param name="fullName">Full name located on the card.</param>
        /// <param name="expMonth">Expiration month.</param>
        /// <param name="expYear">Expiration year.</param>
        /// <param name="cardType">Type of card (amex,
        /// diners_club_carte_blanche, diners_club_international,
        /// jcb, laser, visa_electron, visa, mastercard, discover, dankort,
        /// maestro, uatp, mir).</param>
        /// <param name="cvvTtl">Remaining ttl before the CVV gets
        /// deleted.</param>
        /// <param name="cvv">Card verification value (security code). This
        /// value is not stored permanently.</param>
        /// <param name="ttl">The card's time to live in seconds. Once expired
        /// the
        /// card is deleted from the vault.</param>
        public CardModel(string ccn, string fullName, int expMonth, int expYear, string cardType, int cvvTtl, string cvv = default(string), int? ttl = default(int?))
        {
            Ccn = ccn;
            FullName = fullName;
            ExpMonth = expMonth;
            ExpYear = expYear;
            Cvv = cvv;
            CardType = cardType;
            CvvTtl = cvvTtl;
            Ttl = ttl;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets card number.
        /// </summary>
        [JsonProperty(PropertyName = "ccn")]
        public string Ccn { get; set; }

        /// <summary>
        /// Gets or sets full name located on the card.
        /// </summary>
        [JsonProperty(PropertyName = "fullName")]
        public string FullName { get; set; }

        /// <summary>
        /// Gets or sets expiration month.
        /// </summary>
        [JsonProperty(PropertyName = "expMonth")]
        public int ExpMonth { get; set; }

        /// <summary>
        /// Gets or sets expiration year.
        /// </summary>
        [JsonProperty(PropertyName = "expYear")]
        public int ExpYear { get; set; }

        /// <summary>
        /// Gets or sets card verification value (security code). This value is
        /// not stored permanently.
        /// </summary>
        [JsonProperty(PropertyName = "cvv")]
        public string Cvv { get; set; }

        /// <summary>
        /// Gets or sets type of card (amex, diners_club_carte_blanche,
        /// diners_club_international,
        /// jcb, laser, visa_electron, visa, mastercard, discover, dankort,
        /// maestro, uatp, mir).
        /// </summary>
        [JsonProperty(PropertyName = "cardType")]
        public string CardType { get; set; }

        /// <summary>
        /// Gets or sets remaining ttl before the CVV gets deleted.
        /// </summary>
        [JsonProperty(PropertyName = "cvvTtl")]
        public int CvvTtl { get; set; }

        /// <summary>
        /// Gets or sets the card's time to live in seconds. Once expired the
        /// card is deleted from the vault.
        /// </summary>
        [JsonProperty(PropertyName = "ttl")]
        public int? Ttl { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Ccn == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "Ccn");
            }
            if (FullName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "FullName");
            }
            if (CardType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CardType");
            }
            if (ExpMonth > 12)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "ExpMonth", 12);
            }
            if (ExpMonth < 1)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "ExpMonth", 1);
            }
            if (CvvTtl > 1800)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "CvvTtl", 1800);
            }
            if (CvvTtl < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "CvvTtl", 0);
            }
            if (Ttl != null)
            {
                if (Ttl > 1800)
                {
                    throw new ValidationException(ValidationRules.InclusiveMaximum, "Ttl", 1800);
                }
                if (Ttl < 60)
                {
                    throw new ValidationException(ValidationRules.InclusiveMinimum, "Ttl", 60);
                }
            }
        }
    }
}
