// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Swagger.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Linq;

    public partial class CardReadModel
    {
        /// <summary>
        /// Initializes a new instance of the CardReadModel class.
        /// </summary>
        public CardReadModel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CardReadModel class.
        /// </summary>
        /// <param name="firstSix">First six digits of the card number.</param>
        /// <param name="lastFour">Last four digits of the card number.</param>
        /// <param name="expMonth">Expiration month.</param>
        /// <param name="expYear">Expiration year.</param>
        /// <param name="fullName">Full name located on the card.</param>
        /// <param name="cardType">Type of card (amex,
        /// diners_club_carte_blanche, diners_club_international,
        /// jcb, laser, visa_electron, visa, mastercard, discover, dankort,
        /// maestro, uatp, mir).</param>
        /// <param name="cvvTtl">Remaining ttl before the CVV gets
        /// deleted.</param>
        /// <param name="ttl">Remaining ttl before the card gets deleted. If
        /// -1, card lives forever until manually deleted.</param>
        /// <param name="ccn">Card number.</param>
        public CardReadModel(string firstSix, string lastFour, int expMonth, int expYear, string fullName, string cardType, int cvvTtl, int ttl, string ccn = default(string))
        {
            FirstSix = firstSix;
            LastFour = lastFour;
            Ccn = ccn;
            ExpMonth = expMonth;
            ExpYear = expYear;
            FullName = fullName;
            CardType = cardType;
            CvvTtl = cvvTtl;
            Ttl = ttl;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets first six digits of the card number.
        /// </summary>
        [JsonProperty(PropertyName = "firstSix")]
        public string FirstSix { get; set; }

        /// <summary>
        /// Gets or sets last four digits of the card number.
        /// </summary>
        [JsonProperty(PropertyName = "lastFour")]
        public string LastFour { get; set; }

        /// <summary>
        /// Gets or sets card number.
        /// </summary>
        [JsonProperty(PropertyName = "ccn")]
        public string Ccn { get; set; }

        /// <summary>
        /// Gets or sets expiration month.
        /// </summary>
        [JsonProperty(PropertyName = "expMonth")]
        public int ExpMonth { get; set; }

        /// <summary>
        /// Gets or sets expiration year.
        /// </summary>
        [JsonProperty(PropertyName = "expYear")]
        public int ExpYear { get; set; }

        /// <summary>
        /// Gets or sets full name located on the card.
        /// </summary>
        [JsonProperty(PropertyName = "fullName")]
        public string FullName { get; set; }

        /// <summary>
        /// Gets or sets type of card (amex, diners_club_carte_blanche,
        /// diners_club_international,
        /// jcb, laser, visa_electron, visa, mastercard, discover, dankort,
        /// maestro, uatp, mir).
        /// </summary>
        [JsonProperty(PropertyName = "cardType")]
        public string CardType { get; set; }

        /// <summary>
        /// Gets or sets remaining ttl before the CVV gets deleted.
        /// </summary>
        [JsonProperty(PropertyName = "cvvTtl")]
        public int CvvTtl { get; set; }

        /// <summary>
        /// Gets or sets remaining ttl before the card gets deleted. If -1,
        /// card lives forever until manually deleted.
        /// </summary>
        [JsonProperty(PropertyName = "ttl")]
        public int Ttl { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (FirstSix == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "FirstSix");
            }
            if (LastFour == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "LastFour");
            }
            if (FullName == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "FullName");
            }
            if (CardType == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CardType");
            }
            if (ExpMonth > 12)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "ExpMonth", 12);
            }
            if (ExpMonth < 1)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "ExpMonth", 1);
            }
            if (CvvTtl > 1800)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "CvvTtl", 1800);
            }
            if (CvvTtl < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "CvvTtl", 0);
            }
            if (Ttl > 1800)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "Ttl", 1800);
            }
            if (Ttl < 0)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "Ttl", 0);
            }
        }
    }
}
