// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Swagger.Models
{
    using Microsoft.Rest;
    using Newtonsoft.Json;
    using System.Collections;
    using System.Collections.Generic;
    using System.Linq;

    public partial class CartModel
    {
        /// <summary>
        /// Initializes a new instance of the CartModel class.
        /// </summary>
        public CartModel()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the CartModel class.
        /// </summary>
        /// <param name="cultureCode">ISO 639-1 (language) and ISO 3166-1
        /// (country) code.</param>
        /// <param name="cartItems">List of cart items.</param>
        /// <param name="total">Total of the cart item amounts. The total is
        /// validated against the
        /// sum of the cart item amounts.</param>
        /// <param name="gatewayIntegersOnly">Some payment gateways only accept
        /// integers. If true, it will multiply
        /// the total by 100. For instance, 10.01 will be submitted to the
        /// gateway
        /// as 1001.</param>
        public CartModel(string cultureCode, IList<CartItemModel> cartItems, double total, bool gatewayIntegersOnly)
        {
            CultureCode = cultureCode;
            CartItems = cartItems;
            Total = total;
            GatewayIntegersOnly = gatewayIntegersOnly;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets ISO 639-1 (language) and ISO 3166-1 (country) code.
        /// </summary>
        [JsonProperty(PropertyName = "cultureCode")]
        public string CultureCode { get; set; }

        /// <summary>
        /// Gets or sets list of cart items.
        /// </summary>
        [JsonProperty(PropertyName = "cartItems")]
        public IList<CartItemModel> CartItems { get; set; }

        /// <summary>
        /// Gets or sets total of the cart item amounts. The total is validated
        /// against the
        /// sum of the cart item amounts.
        /// </summary>
        [JsonProperty(PropertyName = "total")]
        public double Total { get; set; }

        /// <summary>
        /// Gets or sets some payment gateways only accept integers. If true,
        /// it will multiply
        /// the total by 100. For instance, 10.01 will be submitted to the
        /// gateway
        /// as 1001.
        /// </summary>
        [JsonProperty(PropertyName = "gatewayIntegersOnly")]
        public bool GatewayIntegersOnly { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (CultureCode == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CultureCode");
            }
            if (CartItems == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "CartItems");
            }
            if (CartItems != null)
            {
                foreach (var element in CartItems)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
